// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'ngCordova'])
.run(function ($ionicPlatform, $ionicPopup) {
    $ionicPlatform.ready(function () {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

            // Don't remove this line unless you know what you are doing. It stops the viewport
            // from snapping when text inputs are focused. Ionic handles this internally for
            // a much nicer keyboard experience.
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }
        // Check for network connection
        if (window.Connection) {
            if (navigator.connection.type == Connection.NONE) {
                $ionicPopup.alert({
                    title: 'No Internet Connection',
                    content: 'Sorry, this app is required Internet connection. Please reconnect and try again.'
                }).then(function (result) {
                    ionic.Platform.exitApp();
                });
            }
        }
    });
})
.controller('FileController', function ($scope, $cordovaDevice, $cordovaCamera, $http, $ionicLoading, $cordovaFile, $cordovaFileTransfer, $cordovaSocialSharing, $ionicActionSheet, $ionicScrollDelegate, $cordovaInAppBrowser) {
    $scope.fileName = "img/demo.png"; //
    $scope.linkShare = "";
    $scope.showShare = false;
    $scope.domain = 'http://how-age.com';
    //$scope.domain = 'http://howagetest.seedex.org';
    $scope.appShareUrl = 'https://play.google.com/store/apps/details?id=com.carina.howoldyoulook';
    var androidAppId = 'com.carina.howoldyoulook';
    var iosAppId = '1223320687';
    var pictureList = new Array();
    var randomAds = 1;//0: show ad after button check, 1: show add after select picture, >1: show ad after select picture and after button check
    $scope.showAdsCheck = function () {
        $http.get($scope.domain + '/api/webapi/get').success(function (data) {
            randomAds = parseInt(data);
        });
    }
    function rand1toN(num) {
        return parseInt(Math.random() * num) + 1;
    }
    $scope.scrollToTop = function () { //ng-click for back to top button
        $ionicScrollDelegate.scrollTop();
    };
    $scope.showLoading = function (message) {
        $('#msg').text('changed text');
        $ionicLoading.show({
            template: '<ion-spinner icon="circles" class="light"></ion-spinner><br/>' + message,
            animation: 'fade-in',
            noBackdrop: true
        });
    };
    function setItem(key, value) {
        window.localStorage.setItem(key, value);
    }
    function getItem(key) {
        return window.localStorage.getItem(key);
    }
    function removeItem(key) {
        window.localStorage.removeItem(key);
    }
    function savePictures(item) {
        var _pictureList = getItem('savePictures');
        if (!_pictureList) {
            setItem('savePictures', item);
            return;
        }
        pictureList = _pictureList.split(',');
        if (pictureList.length > 9) {
            pictureList.pop();
        }
        pictureList.push(item);
        setItem('savePictures', pictureList.join());
    }
    function clearItems()
    {
        removeItem('savePictures');
    }
    $('#img').click(function () {
        $scope.fileName = $(this).attr('src');
        $scope.linkShare = $scope.domain + '/sharem/' + $scope.fileName.split("/").pop();
        $scope.sharePicture();
    });
    $scope.capturePicture = function () {
        $scope.showAdsCheck();
        var options = {
            quality: 75,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 1024,
            targetHeight: 768,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: true,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (sourcePath) {
            $scope.displayPicture(sourcePath);
        }, function (err) {
            //alert(err);
        });
    }
    $scope.selectPicture = function () {
        $scope.showAdsCheck();
        var options = {
            quality: 75,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 1024,
            targetHeight: 768,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false
        };
        $cordovaCamera.getPicture(options).then(
        function (imageURI) {
            window.resolveLocalFileSystemURI(imageURI, function (fileEntry) {
                //alert('nativeURL: ' + fileEntry.nativeURL);
                $scope.displayPicture(fileEntry.nativeURL);
            });
        },
        function (err) {
            //$ionicLoading.show({ template: 'Errore di caricamento...', duration: 500 });
        })
    };
    $scope.displayPicture = function (source) {
        $scope.fileName = source;
        $('#img').attr('src', source).show();
        $('#shareTip').hide();
        $('#btnCheckContainer').show();
        if (randomAds>0)
            $scope.showInsterAds();
    }
    $scope.showInsterAds=function()
    {
        try {
            AdMob.prepareInterstitial({
                adId: admobid.interstitial,
                isTesting: false,
                autoShow: true
            });
        }
        catch (err) {
            //alert(err.message)
        }
    }
    $scope.doCheckAge = function ()
    {
        if (randomAds == 0 || randomAds==2)
            $scope.showInsterAds();
        $('#btnCheckContainer').hide();
        $scope.uploadPicture();
    }
    $scope.cancelCheckAge = function ()
    {
        if (randomAds == 0)
            $scope.showInsterAds();
        $('#img').attr('src', 'img/demo.png').show();
        $('#btnCheckContainer').hide();
        $('#shareTip').hide();
    }
    $scope.uploadPicture = function () {
        //return;
        $('#img').show();
        $scope.showLoading('Correcting your photo');
        var imageURI = $scope.fileName;
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";
        options.chunkedMode = true;

        var params = {};
        params.value1 = "someparams";
        params.value2 = "otherparams";

        options.params = params;

        var ft = new FileTransfer();
        ft.upload(imageURI, encodeURI($scope.domain + "/agemobile/uploadmobile"), uploadSuccess, function (error) {
            $ionicLoading.show({ template: 'There was error... please try again' });
            $ionicLoading.hide();
        }, options);
    }
    function uploadSuccess(r) {
        var result = $.parseJSON(r.response);
        if (result.id > 0) {
            $scope.showLoading('Analysing your photo');
            //alert(result.text);
            $.get($scope.domain + '/agemobile/detectFaceMobile', { imgUrl: result.text, percent: false, type:0 }, function (result) {
                //alert('OK: ' + result.id);
                $ionicLoading.hide();
                if (parseInt(result.id) > 0) {
                    if (result.id == 2) {
                        alertify.error('Sorry, we could not detect your photo. Please try another photo');
                        $scope.showShare = false;
                        return;
                    }
                    var urlshare = $scope.domain + '/sharem/' + result.urlshare;
                    $scope.showShare = true;
                    $scope.linkShare = urlshare;
                    $scope.downPicture();
                    //var urlview = $scope.domain + +result.url;
                    //$scope.fileName = urlview;
                    //savePictures(urlview);
                    //$scope.loadPictures();
                }
                else {
                    alertify.error('Error, please try again with another photo');
					//$('#pictures').html(result.error);
                    $scope.showShare = false;
                }
            });
        }
        else {
            $ionicLoading.hide();
            alertify.error('There was error while detecting your photo, please try another photo');
        }
    }
    $scope.sharePicture = function () {
        if ($scope.linkShare.indexOf('/faces_') == -1)
            return;
        $scope.hideSheet = $ionicActionSheet.show({
            buttons: [
                { text: '<i class="ion-android-share-alt icon-button icon-action success"></i> Share your picture' },
                { text: '<i class="ion-trash-b icon-button icon-action success"></i> Delete picture' },
                //{ text: '<i class="ion-android-download icon-button icon-action"></i> Move File' }
              ],
            titleText: 'Select action',
            cancelText: 'Cancel',
            cssClass: 'text-center',
            buttonClicked: function (index) {
                if (index == 0) {
                    //alert($scope.linkShare);
                    $cordovaSocialSharing.share('How old I look?', 'For fun only', null, $scope.linkShare) // Share via native share sheet
                    .then(function (result) {
                        // alert
                    }, function (err) {
                        // An error occured. Show a message to the user
                    });
                    return true;
                }
                else if(index==1) {
                    $scope.deletePicture();
                    return true;
                }
                else
                {
                    //openRate();
                    //var url=$('#img').attr('src');
                    //$scope.transferFile(url);
                }
            }
        });
    }
    openShare = function () {
        if (device.platform.toLowerCase() == 'ios')
            $scope.appShareUrl = 'https://itunes.apple.com/app/id' + iosAppId;
        $cordovaSocialSharing.share('Guess your age for fun!', 'How old you look', null, $scope.appShareUrl) // Share via native share sheet
    }
    openRate = function () {
        try {
            // Find device platform using the plugin org.apache.cordova.device
            var appId, platform = device.platform.toLowerCase();
            switch (platform) {
                case "ios":
                    appId = iosAppId;
                    break;
                case "android":
                    appId = androidAppId;
                    break;
            }
            LaunchReview.launch(appId, function () {
                //console.log("Successfully launched store app");
            });
        } catch (err) {
            //alert(err.message);
        }
    }
    openApps = function (androidAppId, apleAppId) {
        try {
            // Find device platform using the plugin org.apache.cordova.device
            var appId, platform = device.platform.toLowerCase();
            switch (platform) {
                case "ios":
                    appId = apleAppId;//"585027354";
                    break;
                case "android":
                    appId = androidAppId;//"com.carina.oxfordenglish";
                    break;
            }
            LaunchReview.launch(appId, function () {
                //console.log("Successfully launched store app");
            });
        } catch (err) {
            //alert(err.message);
        }
    }
    openUrl = function (url, target, location) {
        //window.location = url;
        //return;
        if (!target)
            target = '_system';
        if (!location)
            location = 'yes';
        document.addEventListener("deviceready", function () {
            var ref = cordova.InAppBrowser.open(url, target, 'location=' + location);
            //ref.close();
        }, false);
    }
    $scope.downPicture = function () {
        $scope.showLoading('Displaying your photo');
        var url = $scope.linkShare;
        url = url.replace('/sharem', '/content/files/mobile');
        var filename = url.split("/").pop();
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
            fs.root.getDirectory(
                "HowAge",
                {
                    create: true
                },
                function (dirEntry) {
                    dirEntry.getFile(
                        filename,
                        {
                            create: true,
                            exclusive: false
                        },
                        function gotFileEntry(fe) {
                            var p = fe.toURL();
                            fe.remove();
                            ft = new FileTransfer();
                            ft.download(
                                encodeURI(url),
                                p,
                                function (entry) {
                                    $ionicLoading.hide();
                                    $scope.fileName = entry.toURL();
                                    $('#shareTip').show();
                                    $('#img').show();
                                    //copy photo to pictures folder
                                    $scope.transferFile($scope.fileName);
                                    $scope.loadPictures();
                                },
                                function (error) {
                                    $ionicLoading.hide();
                                    alertify.error("Loading error");
                                },
                                false,
                                null
                            );
                        },
                        function () {
                            $ionicLoading.hide();
                            alertify.error("Load file failed");
                        }
                    );
                }
            );
        },
        function () {
            $ionicLoading.hide();
            alertify.error("Request for filesystem failed");
        });
    }
    $scope.loadPictures = function () {
        //$scope.showLoading('Loading your photos');
        //ionic.Platform.ready(function () {
            var url = $scope.linkShare;
            url = url.replace('/sharem', '/content/files/mobile');
            var filename = url.split("/").pop();
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
                fs.root.getDirectory(
                    "HowAge",
                    {
                        create: false
                    },
                    function (directoryEntry) {
                        var directoryReader = directoryEntry.createReader();
                        directoryReader.readEntries(function (entries) {
                            $('#pictures').empty();
                            var fileArr = new Array();
                            for (var i = 0; i < entries.length; ++i) { // sort entries
                                var entry = entries[i];
                                if (entry.isFile && entry.name[0] != '.') {
                                    fileArr.push(entry);
                                    $('#pictures').append('<div class="inline" style="width:50%"><img class="img-age round img-responsive" src="' + entry.toURL() + '"  ng-click="sharePicture()"/></div>');
                                }
                            }
                            $('.img-age').click(function () {
                                $scope.fileName = $(this).attr('src');
                                $('#shareTip').hide();
                                $('#btnCheckContainer').hide();
                                $('#img').show();
                                $scope.linkShare = $scope.domain + '/sharem/' + $scope.fileName.split("/").pop();
                                $scope.sharePicture();
                                $scope.scrollToTop();
                            });
                            $ionicLoading.hide();
                            if (entries.length == 0)
                                $('#img').attr('src', 'img/demo.png').show();
                        }, function (error) {
                            alertify.error('Can not list files');
                        });
                    }
                );
            },
            function () {
                $ionicLoading.hide();
                alertify.error("Error requesting filesystem");
            });
        //});
    }
    $scope.deletePicture = function () {
        $scope.showLoading('Deleting photo');
        $('#img').hide();
        $('#btnCheckContainer').hide();
        $('#shareTip').hide();
        var url = $scope.linkShare;
        url = url.replace('/sharem', '/content/files/mobile');
        var filename = url.split("/").pop();
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
            fs.root.getDirectory(
                "HowAge",
                {
                    create: false
                },
                function (dirEntry) {
                    dirEntry.getFile(
                        filename,
                        {
                            create: false,
                            exclusive: false
                        },
                        function gotFileEntry(fe) {
                            //$scope.imgFile = fe.toURL();
                            fe.remove(function (file) {
                                $scope.loadPictures();
                                $.get($scope.domain + '/agemobile/deletePhoto', { img: filename, mobile: true }, function (result) {
                                    $ionicLoading.hide();
                                });
                            }, function () {
                                $ionicLoading.hide();
                                //alert("Delete file failed");
                            });
                        },
                        function (error) {
                            $ionicLoading.hide();
                            //console.log("Error deleting file");
                        }
                    );
                }
            );
        },
        function () {
            $ionicLoading.hide();
            //console.log("Error requesting filesystem");
        });
    }
    window.setTimeout(function () {
        $scope.loadPictures();
    }, 1000);
    //document.addEventListener('deviceready', function () {
    //    $scope.loadPictures();
    //}, false);
    $scope.transferFile = function (url) {
        ionic.Platform.ready(function () {
            var filename = url.split("/").pop();
            var targetPath = cordova.file.externalRootDirectory + 'Pictures/' + filename;
            //alert(targetPath);
            $cordovaFileTransfer.download(url, targetPath, {}, true).then(function (result) {
                //$ionicLoading.show({ template: 'Save file success!', duration: 1000 });
            }, function (error) {
                //$ionicLoading.show({ template: 'Could not save file', duration: 1000 });
            }, function (progress) {
                //$scope.downloadProgress = (progress.loaded / progress.total) * 100;
            });
        });
    }
});
